﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Web.Security;

public partial class _Default : System.Web.UI.Page 
{
    private bool loggedIn = false;
    private bool loginFailed = false;
    private int userid;
    private string username;
    private string displayName;
    private string email;
    private bool showEmail;
    private DateTime createDate;
    private int accessLevel;

    public enum var
    {
        GET, POST, SESSION, COOKIE
    }
    public enum clean{
        DB
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        authenticate();

        string content = null;
        content += header();
        content += layout();
        
        if (getVariable("logon", var.GET) == "true" || loginFailed)
        {
            content += showLogon();
        }
        else
        {
            bool showblogs = true;
            int blogID = 0;
            switch (getVariable("option", var.GET))
            {
                case "writeBlog":
                case "editBlog":
                    if (accessLevel < 100)
                    {
                        break;
                    }
                    showblogs = false;
                    try
                    {
                        blogID = Convert.ToInt16(getVariable("blogID", var.GET));
                    }
                    catch { }
                    content += writeBlog(blogID);
                    break;
                case "deleteBlog":
                    if (accessLevel < 100)
                    {
                        break;
                    }
                    try
                    {
                        blogID = Convert.ToInt16(getVariable("blogID", var.GET));
                    }
                    catch { }
                    content += deleteBlog(blogID);
                    break;
            }
            switch (getVariable("option", var.POST))
            {
                case "Save Blog":
                    if (accessLevel < 100)
                    {
                        break;
                    }
                    try
                    {
                        blogID = Convert.ToInt16(getVariable("blogID", var.POST));
                    }
                    catch { }
                    content += saveBlog(blogID);
                    break;
            }
            if (showblogs)
            {
                content += showBlogs();
            }
            
        }
        content += footer();
        Response.Write(content);
    }
    private string header()
    {
        string content = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"" +
             "\"http://www.w3.org/TR/html4/strict.dtd\">" +
         @"<html>
        <head>
            <title>cSharp Blog</title>
            <link rel='stylesheet' type='text/css' href='style.css'>
        </head>
        <body>";
        return content;
    }
    private string layout()
    {
        string content = @"            <center><img src='header.png'></center>
            <div class='rightBar'>
                <div class='title'>C# Blog Menu</div>
                <ul>
                    <li>";
        content += (loggedIn) ? "<a href='default.aspx?logon=false'>Log Out</a>" : "<a href='default.aspx?logon=true'>Log In </a>";            
        content += "</li>";
        if (loggedIn && accessLevel == 255)
        {
            content += "<li><a href=''>Create Account</a></li>";
        }
        if (loggedIn && accessLevel >= 100)
        {
            content += @"<li><a href='default.aspx?option=writeBlog'>Write Blog Entry</a></li>
                        <li><a href=''>See New Entries</a></li>";
        }
        content += @"</ul>
            </div>";
        return content;
    }
    private string showLogon()
    {
        string content = @"<center><div class='login'>
            <form method='POST' action='default.aspx'>
                Username: <input name='username'><br>
                Password: <input name='password' type='password'><br>
                <div class='button'><input type='submit' value='Log In'></div>";
        if (loginFailed)
        {
            content += "<div class='error'>The username/password combination is invalid</div>";
        }
        content += @"</form>
        </div></center>";

        return content;
    }
    private string showBlogs()
    {
        string content = null;
        string select = "SELECT top 30 blogID, blogTitle, blogText, displayName, displayDate, " +
	        "CASE " +
		        "WHEN showEmail = 1 THEN ' (<a href=\"mailto: ' + email + '\">' + email + '</a>)' " +
		        "ELSE '' " +
	        "END AS 'email', " +
               "(SELECT COUNT(*) FROM comments WHERE blogID=a.blogID and visible=1) as Comments, " +
               "b.userID " +
        "FROM blogs a " +
	        "JOIN users b on " +
		        "a.userID=b.userID " +
        "WHERE visible=1 " +
        "ORDER BY displayDate Desc";

        SqlDataReader dr = query(select);
        while (dr.Read())
        {
            bool allowEdit = (accessLevel == 255 || (accessLevel >= 100 && userid == Convert.ToInt16(dr["userID"])))? true: false;

            content += @"<div class='blogEntry'>
                <div class='blogTitle'>
                    <div class='title'>" + dr["blogTitle"] + @"</div>";
            if (allowEdit)
            {
                content += "<div class='commands'>" +
                    "<a href='default.aspx?option=editBlog&blogID=" + dr["blogID"] + " '>Edit</a> / " +
                    "<a href='default.aspx?option=deleteBlog&blogID=" + dr["blogID"] + "'>Delete</a>" +
                "</div>";
            }
            content += @"</div>
                <div class='blogSubTitle'>
                    <div class='author'>By " + dr["displayName"] + dr["email"] + @"</div>
                    <div class='date'>" + Convert.ToDateTime(dr["displayDate"]).ToString("hh:mmtt dd MMM yyyy") + @"</div>
                </div>
                <div class='text'>" + Convert.ToString(dr["blogText"]).Replace("\n", "<br>") + @"</div>
                <div class='comments'><a href=''>Comments (" + dr["Comments"] + @") </a></div>
            </div>";
        }
        dr.Dispose();
        return content;
    }
    private string writeBlog(int blogID)
    {
        string content = null, blogTitle = null, blogText = "", blogDisplayName = displayName, blogEmail = email;
        DateTime displayDate = DateTime.Now, blogCreateDate = DateTime.Now, modifiedDate = DateTime.Now;
        bool visible = true, blogShowEmail = showEmail;
        int numComments = 0;

        if (blogID > 0)
        {
            //editing blog
            string select = @"SELECT a.userID, blogTitle, blogText, visible, a.createDate, displayDate, modifiedDate,
                (SELECT COUNT(*) FROM comments WHERE blogID=a.blogID and visible=1) as Comments,
                displayName, email, showEmail
            FROM blogs a
	            JOIN users b
		            on a.userID = b.userID
            WHERE a.blogID = " + blogID;
            bool mayEdit = false;
            SqlDataReader dr = query(select);
            if (dr.HasRows)
            {
                dr.Read();
                if (accessLevel == 255 || (userid == Convert.ToInt16(dr["userID"])))
                {
                    mayEdit = true;
                    blogTitle = Convert.ToString(dr["blogTitle"]);
                    blogText = Convert.ToString(dr["blogText"]);
                    visible = (Convert.ToInt16(dr["visible"]) == 0) ? false : true;
                    try { blogCreateDate = Convert.ToDateTime(dr["createDate"]); } catch { }
                    try { modifiedDate = Convert.ToDateTime(dr["modifiedDate"]); } catch { }
                    numComments = Convert.ToInt16(dr["Comments"]);
                    blogDisplayName = Convert.ToString(dr["displayName"]);
                    blogEmail = Convert.ToString(dr["email"]);
                    blogShowEmail = (Convert.ToInt16(dr["showEmail"]) == 1) ? true : false;
                }
            }
            dr.Dispose();
            if (!mayEdit)
            {
                return "<div class='error'>Error: Not Authorized</div>";
            }

        }
        content += @"<form method='POST' action='default.aspx' style='display: inline;'><div class='blogEntry'>
            <div class='blogTitle'>
                <div class='title'>Title:<input name='blogTitle' size=60 value='" + blogTitle + @"'> Visible:<input type='checkbox' name='visible'";
        if (visible) { content += " checked"; }
        content += @"</div>
            </div>
            <div class='blogSubTitle'>
                <div class='author'>By " + blogDisplayName;
        if (blogShowEmail) { content += " (<a href=\"mailto: " + blogEmail + "\">" + blogEmail + "</a>)"; }
        content += "</div><div class='date'>";
        if (blogID > 0)
        {
            content += "Display<input name='displayDate' value='" + displayDate + @"'><br>" +
                "Modified<input name='displayDate' value='" + modifiedDate + @"' disabled><br>" +
                "Created<input name='displayDate' value='" + blogCreateDate + @"' disabled><br>";
        }
        else
        {
            content += "<input name='displayDate' value='" + displayDate + @"'>";
        }
        
        content += @"</div>
            </div>
            <div class='text'><textarea name='blogText' rows=10 style='width: 100%;'>" + blogText + @"</textarea></div>
            <div class='comments'>Comments (" + numComments + @")</div>
        </div>
        <input type='hidden' name='blogID' value='" + blogID + @"'>
        <input type='submit' name='option' value='Save Blog'>
        <input type='reset' value='Clear'></form>
        <form action='default.aspx' style='display: inline;'>
            <input type='submit' value='Cancel'>
        </form>";

        return content;
    }
    private string saveBlog(int blogID)
    {
        string content = null;

        //initialize variables
        string select = null;
        string blogTitle = sanitize(getVariable("blogTitle", var.POST), clean.DB);
        string blogText = sanitize(getVariable("blogText", var.POST), clean.DB);
        int visible = (getVariable("visible", var.POST) == "off") ? 0 : 1;
        DateTime displayDate = DateTime.Now;
        try
        {
            displayDate = Convert.ToDateTime(getVariable("displayDate", var.POST));
        }
        catch { }

        if (blogID > 0)
        {
            //edit an existing blog
            if (accessLevel < 255)
            {
                bool mayEdit = false;
                select = "SELECT userid FROM blogs WHERE blogID=" + blogID;
                SqlDataReader dr = query(select);
                if (dr.HasRows)
                {
                    dr.Read();
                    if (userid == Convert.ToInt16(dr["userid"]))
                    {
                        mayEdit = true;
                    }
                }
                dr.Dispose();
                if (!mayEdit)
                {
                    return "<div class='error'>Error: Not Authorized</div>";
                }
            }

            select = @"UPDATE blogs SET 
                blogTitle='" + blogTitle + @"',
                blogText='" + blogText + @"',
                visible=" + visible + @",
                displayDate='" + displayDate + @"',
                modifiedDate=getdate()
            WHERE blogID=" + blogID;
        }
        else
        {
            //create a new blog
            select = @"INSERT INTO blogs
            (userID, blogTitle, blogText, visible, createDate, displayDate, modifiedDate)
                VALUES
            (" + userid + ", '" + blogTitle + "', '" + blogText + "', " + visible + ", getdate(), '" + displayDate + "', getdate())";
            
        }
        query(select);

        return content;
    }
    private string deleteBlog(int blogID)
    {
        string content = null;
        string select = null;

        //see if the user can delete this blog
        if (accessLevel < 255)
        {
            bool mayEdit = false;
            select = "SELECT userid FROM blogs WHERE blogID=" + blogID;
            SqlDataReader dr = query(select);
            if (dr.HasRows)
            {
                dr.Read();
                if (Convert.ToInt16(dr["userid"]) == userid)
                {
                    mayEdit = true;
                }
            }
            dr.Dispose();
            if(!mayEdit){
                return "<div class='error'>Error: Not Authorized</div>";
            }
        }

        select = "UPDATE blogs SET visible=0, modifiedDate=getdate() WHERE blogID=" + blogID;
        query(select);
        content += "<div class='error'>Blog Deleted</div>";
        return content;
    }
    private string footer()
    {
        string content = "</body></html>";
        return content;
    }

    private void authenticate()
    {
        string _username = null, password = null;
        if (getVariable("logon", var.GET) == "false")
        {
            cookie(false, null);
            return;
        }
        if (getVariable("username", var.POST) != null && getVariable("password", var.POST) != null)
        {   //check for POST vars from the login form
            _username = sanitize(getVariable("username", var.POST), clean.DB);
            password = FormsAuthentication.HashPasswordForStoringInConfigFile(getVariable("password", var.POST), "MD5");
        }
        else if (Session["blogUsername"] != null && Session["blogPassword"] != null)
        {   //check for sessions
            _username = sanitize(Session["blogUsername"].ToString(), clean.DB);
            password = sanitize(Session["blogPAssword"].ToString(), clean.DB);
        }
        else
        {   //check for cookies
            HttpCookie usernameCookie = HttpContext.Current.Request.Cookies["blogUsername"];
            HttpCookie passwordCookie = HttpContext.Current.Request.Cookies["blogPassword"];
            if (usernameCookie != null && passwordCookie != null)
            {
                _username = sanitize(usernameCookie.Value, clean.DB);
                password = sanitize(passwordCookie.Value, clean.DB);
            }
        }

        if (_username == null || password == null)
        {
            return;
        }

        string select = "SELECT userid, username, displayName, email, showEmail, createDate, accessLevel " + 
            "FROM users WHERE username='" + _username + "' AND password='" + password + "'";
        SqlDataReader dr = query(select);
        if (dr.HasRows)
        {
            dr.Read();
            loggedIn = true;
            userid = Convert.ToInt16(dr["userid"]);
            username = Convert.ToString(dr["username"]);
            displayName = Convert.ToString(dr["displayName"]);
            email = Convert.ToString(dr["email"]);
            showEmail = (Convert.ToInt16(dr["showEmail"]) == 1) ? true : false;
            createDate = Convert.ToDateTime(dr["createDate"]);
            accessLevel = Convert.ToInt16(dr["accessLevel"]);
            cookie(true, password); //set cookies and sessions
        }
        else
        {
            loggedIn = false;
            if (getVariable("username", var.POST) != null && getVariable("password", var.POST) != null)
            {
                loginFailed = true; //remove any sessions or cookies
            }
            cookie(false, null);
        }
        dr.Dispose();        
    }
    private void cookie(bool set, string password)
    {
        HttpCookie usernameCookie = new HttpCookie("blogUsername");
        HttpCookie passwordCookie = new HttpCookie("blogPassword");
        switch (set)
        {
            case true:
                //set cookies
                usernameCookie.Value = username;
                passwordCookie.Value = password;
                usernameCookie.Expires = System.DateTime.Now.AddHours(24);
                passwordCookie.Expires = System.DateTime.Now.AddHours(24);
                HttpContext.Current.Response.Cookies.Add(usernameCookie);
                HttpContext.Current.Response.Cookies.Add(passwordCookie);

                //set sessions
                Session["blogUsername"] = username;
                Session["blogPassword"] = password;
                break;
            case false:
                //set cookies to expire yesterday
                usernameCookie = HttpContext.Current.Request.Cookies["blogUsername"];
                passwordCookie = HttpContext.Current.Request.Cookies["blogPassword"];
                try
                {
                    usernameCookie.Expires = DateTime.Now.AddDays(-1);
                    HttpContext.Current.Response.Cookies.Add(usernameCookie);
                }
                catch { }
                try
                {
                    passwordCookie.Expires = DateTime.Now.AddDays(-1);
                    HttpContext.Current.Response.Cookies.Add(passwordCookie);
                }
                catch { }

                //kill sessions
                Session.Abandon();
                break;
        }
    }
    private SqlDataReader query(string select)
    {
        SqlConnection conn = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["blogDatabase"].ConnectionString);
        conn.Open();
        SqlCommand cm = new SqlCommand(select, conn);
        return cm.ExecuteReader();
    }
    private string getVariable(string input, var varType)
    {
        string variable = null;
        switch (varType)
        {
            case var.GET:
                try
                {
                    int doesVarExist = Request.QueryString[input].Length;
                    variable = Request.QueryString[input];
                }
                catch { }
                break;
            case var.POST:
                try
                {
                    if (Request.Form.Get(input).Length > 0)
                    {
                        variable = Request.Form.Get(input);
                    }
                }
                catch { }
                break;
        }
        
        return variable;
    }
    private string sanitize(string value, clean type)
    {
        switch (type)
        {
            case clean.DB:
                value = value.Replace("'", "''");
                break;
        }

        return value;
    }

}
